% $Id$ %
\chapter{Plugins}\label{ref:plugins}
Plugins are programs that Rockbox can load and run. Only one plugin can
be loaded at a time. Plugins have exclusive control over the user interface.
This means you cannot switch back and forth between a plugin and Rockbox. When
a plugin is loaded, you need to exit it to return to the Rockbox interface.
Most plugins will not interfere with music playback but some of them will stop
playback while running. Plugins have the file extension \fname{.rock}. Most of
them can be started from \setting{Browse Plugins} in the \setting{Main Menu}.\\

Viewer plugins get started automatically by opening an associated file (i.e.
text files%
\opt{lcd_bitmap}{, chip8 games}%
), or from the \setting{Open with} option on the \setting{Context Menu}.

\section{Games}
\opt{lcd_bitmap}
    {See also the Chip{}-8 emulator in \reference{ref:Chip8emulator}
    \opt{recorder,recorderv2fm,h100,m5,lcd_color}
    {and Rockboy in \reference{ref:Rockboy}}.}

\opt{lcd_bitmap}{\input{plugins/blackjack.tex}}

\opt{lcd_bitmap}{\input{plugins/brickmania.tex}}

\opt{lcd_bitmap}{\input{plugins/bubbles.tex}}

\opt{lcd_bitmap}{\input{plugins/chessbox.tex}}

\opt{lcd_color}{\input{plugins/clix.tex}}

\opt{lcd_bitmap}{\input{plugins/chopper.tex}}

{\input{plugins/dice.tex}}

\opt{swcodec}{\input{plugins/doom.tex}}

{\input{plugins/flipit.tex}}

\opt{lcd_bitmap}{\input{plugins/goban.tex}}

\opt{lcd_non-mono}{\nopt{h10_5gb,ipodmini,c200}{
  \input{plugins/invadrox.tex}}}

{\input{plugins/jackpot.tex}}

\opt{lcd_bitmap}{\input{plugins/jewels.tex}}

\opt{lcd_bitmap}{\input{plugins/mazezam.tex}}

\opt{lcd_bitmap}{\input{plugins/minesweeper.tex}}

\opt{player}{\input{plugins/nim.tex}}

\opt{h100,m5,lcd_color}{\nopt{c200}{\input{plugins/pacbox.tex}}}

\opt{lcd_bitmap}{\input{plugins/pegbox.tex}}

\opt{lcd_bitmap}{\input{plugins/pong.tex}}

\opt{lcd_bitmap}{\input{plugins/robotfindskitten.tex}}

{\input{plugins/rockblox.tex}}

\opt{lcd_bitmap}{\input{plugins/rockblox1d.tex}}

\opt{lcd_bitmap}{\input{plugins/rocklife.tex}}

\opt{lcd_bitmap}{\input{plugins/sliding.tex}}

\opt{lcd_bitmap}{\input{plugins/snake.tex}}

\opt{lcd_bitmap}{\input{plugins/snake2.tex}}

\opt{lcd_bitmap}{\input{plugins/sokoban.tex}}

\opt{lcd_bitmap}{\input{plugins/solitaire.tex}}

\opt{lcd_bitmap}{\input{plugins/spacerocks.tex}}

\opt{lcd_bitmap}{\input{plugins/star.tex}}

\opt{lcd_bitmap}{\input{plugins/sudoku.tex}}

\opt{lcd_bitmap}{\input{plugins/wormlet.tex}}

\opt{lcd_bitmap}{\input{plugins/xobox.tex}}

\section{Demos}

\opt{lcd_bitmap}{\input{plugins/bounce.tex}}

{\input{plugins/credits.tex}}

{\input{plugins/cube.tex}}

\opt{lcd_bitmap}{\input{plugins/demystify.tex}}

\opt{lcd_bitmap}{\input{plugins/fire.tex}}

{\input{plugins/logo.tex}}

\opt{lcd_bitmap}{\input{plugins/mandelbrot.tex}}

{\input{plugins/mosaic.tex}}

\opt{lcd_bitmap}{\input{plugins/oscilloscope.tex}}

\opt{tagcache}{\opt{lcd_bitmap}{\input{plugins/pictureflow.tex}}}

\opt{lcd_bitmap}{\input{plugins/plasma.tex}}

{\input{plugins/snow.tex}}

\opt{lcd_bitmap}{\input{plugins/starfield.tex}}

\opt{lcd_bitmap}{\input{plugins/vumeter.tex}}

\section{\label{ref:Viewersplugins}Viewers}

Viewers are plugins which are associated with specific file extensions.
They cannot be run directly but are started by ``playing''
the associated file. Viewers are stored in the
\textbf{/.rockbox/rocks/viewers/ }directory.

{\input{plugins/shortcuts.tex}}

\opt{lcd_bitmap}{\input{plugins/chip8emulator.tex}}

\opt{lcd_bitmap}{\input{plugins/jpegviewer.tex}}

\opt{large_plugin_buffer}{\input{plugins/lua.tex}}

\opt{swcodec}{\input{plugins/midiplay.tex}}

\opt{recorder,recorderv2fm,ondio}{\input{plugins/movieplayer.tex}}

\opt{lcd_bitmap}{\opt{swcodec}{\input{plugins/mpegplayer.tex}}}

\opt{lcd_bitmap}{\opt{lcd_color}{\input{plugins/pngviewer.tex}}}

\opt{lcd_color}{\input{plugins/ppmviewer.tex}}

\opt{recorder,recorderv2fm,ondio}{\input{plugins/rockbox_flash.tex}}

\opt{recorder,recorderv2fm,h100,m5,lcd_color}{\input{plugins/rockboy.tex}}

{\input{plugins/search.tex}}

{\input{plugins/sort.tex}}

{\input{plugins/text_viewer.tex}}

{\input{plugins/vbrfix.tex}}

\opt{recorder,recorderv2fm,ondio}{\input{plugins/wavplay.tex}}

\opt{lcd_bitmap}{\input{plugins/zxbox.tex}}

\section{Applications}

\opt{player,recorder,recorderv2fm}{\input{plugins/alpinecdc.tex}}

{\input{plugins/batterybenchmark.tex}}

\opt{lcd_bitmap}{\input{plugins/calculator.tex}}

\opt{rtc}{\input{plugins/calendar.tex}}

{\input{plugins/chess_clock.tex}}

\opt{rtc}{\input{plugins/clock.tex}}

{\input{plugins/disktidy.tex}}

\opt{player}{\input{plugins/euro_converter.tex}}

\opt{recorder,recorderv2fm,ondio}{\input{plugins/firmware_flash.tex}}

{\input{plugins/keybox.tex}}

\opt{HAVE_BACKLIGHT}{\input{plugins/lamp.tex}}

{\input{plugins/md5sum.tex}}

{\input{plugins/metronome.tex}}

{\input{plugins/random_folder_advance_config.tex}}

\opt{lcd_color}{\input{plugins/rockpaint.tex}}

\opt{recorder,recorderv2fm,ondio}{\input{plugins/split_editor.tex}}

{\input{plugins/stats.tex}}

{\input{plugins/stopwatch.tex}}

\opt{lcd_bitmap}{\input{plugins/text_editor.tex}}
